--test touch
maps={}
height = screen.height()
width= screen.width()
carrots=0;
eggs=0;
silverkey=false 
goldkey=false
bronzekey=false
conveyors=false
goal={}
black = color.new(0,0,0)
white = color.new(255,255,255)
require "curentlevels"

function choosescreen()
   screen.fillrect(0,0,width,height,black)
   screen.fillrect(80, 80, 80, 80, color.new(40,40,40))
   screen.drawrect(80,80,160,160,white)
   screen.fillrect(240, 80, 80, 80, color.new(40,40,40))
   screen.drawrect(240,80,320,160,white)
   local aimg = image.load("carrot_icon.png")
   aimg:draw(100, 100, 40 ,40)
   aimg:close()
   aimg = image.load("egg_icon.png")
   aimg:draw(260, 100, 40 ,40)
   aimg:close()
   text.size(25)
   text.color(white)
   text.draw(30,30,"Choose gametype","center",width)

   screen.update()
   
   while 1 do 
      if control.read()==1 then
	 if control.isTouch()==1 then
	    x,y = touch.pos()
	    if touch.down() == 1 then
	       if x >= 80 and x<=160 and y >= 80 and y <= 160 then 
		  require "clvls"
		  level = carrotslevel
		  break
	       elseif x >= 240 and x<=320 and y >= 80 and y <= 160 then 
		  require "elvls"
		  level = eggslevel
		  break
	       end
	    end	    
	 end
      else
	 os.sleep(5)
      end
   end
end


choosescreen()


map2 = maps[level]()

function setTile(x,y,n)
   map2[y+1][x+1]=n
   drawtile(x,x,y,y)
end

tiles = image.load("tiles.png")

function drawtiles()
   for w = 0, 24 do
      for h = 0, 14 do
	 tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)), 16*h-(16*(math.floor(map2[h+1][w+1]/8))), 16*w ,16*h,16,16)
      end
   end
end

function drawtile(w1,w2,h1,h2)
   
   for w = w1 >= 0 and w1 or 0, w2 <= 24 and w2 or 24 do
      for h = h1 >= 0 and h1 or 0, h2 <= 14 and h2 or 14 do
	 tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)), 16*h-(16*(math.floor(map2[h+1][w+1]/8))), 16*w ,16*h,16,16)
      end
   end
end


boby = {
   up = {0,1,2,3,4,5,6,7},
   left = {8,9,10,11,12,13,14,15},
   right = {16,17,18,19,20,21,22,23},
   down = {24,25,26,27,28,29,30,31},
   fade = {32,33,34,35,36,37,38,39},
   wait = {40,41,42,40,40,41,42,40,40,41,42,40,40,41,42,40},
   die = {44,45,46,47}
}



boby_state = "wait"

bobypos = {x=1,y=1}

bobyimg = image.load("boby.png")

function drawconveyors(i)
   for w = 0, 24 do
      for h = 0, 14 do
	 if map2[h+1][w+1]==40 then
	    tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)+i), 16*h-(16*(math.floor(map2[h+1][w+1]/8))), 16*w ,16*h,16-i,16)
	    tiles:draw(16*w+(16-i)-(16 * (map2[h+1][w+1]%8)), 16*h-(16*(math.floor(map2[h+1][w+1]/8))), 16*w+(16-i) ,16*h, 16-(16-i),16)
	 elseif map2[h+1][w+1]==41 then
	    tiles:draw(16*w+2*i-(16 * (map2[h+1][w+1]%8)+i), 16*h-(16*(math.floor(map2[h+1][w+1]/8))), 16*w+i ,16*h,16-i,16)
	    tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)+(16-i)), 16*h-(16*(math.floor(map2[h+1][w+1]/8))), 16*w ,16*h,16-(16-i),16)
	 elseif map2[h+1][w+1]==42 then
	    tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)), 16*h-(16*(math.floor(map2[h+1][w+1]/8))+i), 16*w ,16*h,16,16-i)
	    tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)), 16*h+(16-i)-(16*(math.floor(map2[h+1][w+1]/8))), 16*w ,16*h+(16-i), 16,16-(16-i))
	 elseif map2[h+1][w+1]==43 then
	    tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)), 16*h+2*i-(16*(math.floor(map2[h+1][w+1]/8))+i), 16*w ,16*h+i,16,16-i)
	    tiles:draw(16*w-(16 * (map2[h+1][w+1]%8)), 16*h-(16*(math.floor(map2[h+1][w+1]/8))+(16-i)), 16*w ,16*h,16,16-(16-i))
	 end
      end
   end
   if  boby_state == "wait" then
      os.sleep(10)
   end
end

function  hideboby()
   local w = bobypos.x
   local h = bobypos.y
   if map2[bobypos.y +1][bobypos.x +1] == 27 then
      tiles:draw(16*w-(16 * ( map2[bobypos.y +1][bobypos.x +1]%8)), 16*h-(16*(math.floor(map2[bobypos.y +1][bobypos.x +1]/8))), 16*w ,16*h+10,16,6)
      tiles:draw(16*w-(16 * ( map2[bobypos.y +1][bobypos.x +1]%8)), 16*h-(16*(math.floor(map2[bobypos.y +1][bobypos.x +1]/8))), 16*w ,16*h,4,16)
   elseif map2[bobypos.y +1][bobypos.x +1] == 26 then
      tiles:draw(16*w-(16 * ( map2[bobypos.y +1][bobypos.x +1]%8)), 16*h-(16*(math.floor(map2[bobypos.y +1][bobypos.x +1]/8))), 16*w ,16*h+10,16,6)
      tiles:draw(16*w-(16 * ( map2[bobypos.y +1][bobypos.x +1]%8)), 16*h-(16*(math.floor(map2[bobypos.y +1][bobypos.x +1]/8))), 16*w+12 ,16*h,4,16)
   elseif map2[bobypos.y +1][bobypos.x +1] == 28 then
      tiles:draw(16*w-(16 * ( map2[bobypos.y +1][bobypos.x +1]%8)), 16*h-(16*(math.floor(map2[bobypos.y +1][bobypos.x +1]/8))), 16*w ,16*h+10,16,6)
   end
end    

function creat_co_boby()
   co_boby = coroutine.create(
      function ()
	 local v
	 while gamerun do
	    if boby_state  == "wait" then
	       if  map2[bobypos.y +1][bobypos.x +1] >= 26 and map2[bobypos.y +1][bobypos.x +1] <= 28 then
		  bobyimg:draw(16*bobypos.x -(18 * (map2[bobypos.y +1][bobypos.x +1]%8)), 16*bobypos.y -(25 *  math.floor( map2[bobypos.y +1][bobypos.x +1]/8))-9,16*bobypos.x,16*bobypos.y-9,18,25)
		  hideboby()
		  coroutine.yield()
	       else
		  while boby_state == "wait" do

		     v = boby.wait
		     for i = 0, 15 do
			drawtile(bobypos.x, bobypos.x,bobypos.y-1,bobypos.y)
			drawconveyors(i)
			bobyimg:draw(16*bobypos.x -(18 * (v[i+1]%8)), 16*bobypos.y -(25 *  math.floor(v[i+1]/8))-9,16*bobypos.x,16*bobypos.y-9,18,25)
			coroutine.yield()
			if boby_state ~= "wait" then
			   break 
			end
		     end
		  end
	       end
	    elseif  boby_state == "left" then
	       if canmove(boby_state, bobypos.x -1, bobypos.y) then
		  v = boby.left
		  for i = 0, 15 do
		     drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		     bobyimg:draw(16*bobypos.x -(18 * (v[(i%8)+1]%8))-i, 16*bobypos.y -(25 *  math.floor(v[(i%8)+1]/8))-9,16*bobypos.x-i,16*bobypos.y-9,18,25)
		     coroutine.yield()
		  end
		  update_before()
		  bobypos.x = bobypos.x -1

	       end
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "right" then
	       if canmove(boby_state, bobypos.x +1, bobypos.y) then
		  v = boby.right
		  for i = 0, 15 do
		     drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		     bobyimg:draw(16*bobypos.x -(18 * (v[(i%8)+1]%8))+i, 16*bobypos.y -(25 *  math.floor(v[(i%8)+1]/8))-9,16*bobypos.x+i,16*bobypos.y-9,18,25)
		     coroutine.yield()
		  end
		  update_before()
		  bobypos.x = bobypos.x +1

	       end
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "up" then
	       if canmove(boby_state, bobypos.x, bobypos.y-1) then
		  v = boby.up
		  for i = 0, 15 do
		     drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-2,bobypos.y+1)
		     bobyimg:draw(16*bobypos.x -(18 * (v[(i%8)+1]%8)), 16*bobypos.y -(25 *  math.floor(v[(i%8)+1]/8))-i-9,16*bobypos.x,16*bobypos.y-i-9,18,25)
		     coroutine.yield()
		  end
		  update_before()
		  bobypos.y = bobypos.y -1

	       end
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "down" then
	       if canmove(boby_state, bobypos.x, bobypos.y+1) then
		  v = boby.down
		  for i = 0, 15 do
		     drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		     bobyimg:draw(16*bobypos.x -(18 * (v[(i%8)+1]%8))-1, 16*bobypos.y -(25 *  math.floor(v[(i%8)+1]/8))+i-9,16*bobypos.x-1,16*bobypos.y+i-9,18,25)
		     coroutine.yield()
		  end
		  update_before()
		  bobypos.y = bobypos.y +1

	       end
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "die" then
	       v = boby.die
	       for i = 0, 3 do
		  drawtile(bobypos.x, bobypos.x,bobypos.y-1,bobypos.y)
		  bobyimg:draw(16*bobypos.x -(18 * (v[(i%4)+1]%8)), 16*bobypos.y -(25 *  math.floor(v[(i%4)+1]/8))-9,16*bobypos.x,16*bobypos.y-9,18,25)
--		  screen.update()
		  coroutine.yield()
		  os.sleep(30)
	       end
	       reset()
	    elseif  boby_state == "fade" then
	       v = boby.fade
	       for i = 0, 7 do
		  drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		  bobyimg:draw(16*bobypos.x -(18 * (v[(i%8)+1]%8)), 16*bobypos.y -(25 *  math.floor(v[(i%8)+1]/8))-9,16*bobypos.x,16*bobypos.y-9,18,25)
--		  screen.update()
		  coroutine.yield()
		  os.sleep(15)
	       end
	       nextlvl()
	       local f = io.open("curentlevels.lua","w")
	       if package.loaded["clvls"] ~= nil then
		  f:write("carrotslevel = ".. tostring(level) .. "\n" .. "eggslevel = " .. tostring(eggslevel) .. "\n")
	       else 
		  f:write("carrotslevel = ".. tostring(carrotslevel) .. "\n" .. "eggslevel = " .. tostring(level) .. "\n")
	       end
	       f:close()

	    elseif  boby_state == "trans_left" then
	       for i = 0, 15 do
		  drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		  bobyimg:draw(16*bobypos.x -(18 * (43%8))-i, 16*bobypos.y -(25 *  math.floor(43/8))-9,16*bobypos.x-i,16*bobypos.y-9,18,25)
		  coroutine.yield()
	       end
	       bobypos.x = bobypos.x -1
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "trans_right" then
	       for i = 0, 15 do
		  drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		  drawconveyors(i)
		  bobyimg:draw(16*bobypos.x -(18 * (43%8))+i, 16*bobypos.y -(25 *  math.floor(43/8))-9,16*bobypos.x+i,16*bobypos.y-9,18,25)
		  coroutine.yield()
	       end
	       bobypos.x = bobypos.x +1
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "trans_down" then
	       for i = 0, 15 do
		  drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		  drawconveyors(i)
		  bobyimg:draw(16*bobypos.x -(18 * (43%8))-1, 16*bobypos.y -(25 *  math.floor(43/8))+i-9,16*bobypos.x-1,16*bobypos.y+i-9,18,25)
		  coroutine.yield()
	       end
	       bobypos.y = bobypos.y +1
	       boby_state = "wait" 
	       update_after()
	    elseif  boby_state == "trans_up" then
	       for i = 0, 15 do
		  drawtile(bobypos.x-1, bobypos.x+1,bobypos.y-1,bobypos.y+1)
		  drawconveyors(i)
		  bobyimg:draw(16*bobypos.x -(18 * (43%8))-1, 16*bobypos.y -(25 *  math.floor(43/8))-i-9,16*bobypos.x-1,16*bobypos.y-i-9,18,25)
		  coroutine.yield()
	       end
	       bobypos.y = bobypos.y -1
	       boby_state = "wait" 
	       update_after()
	    end
	 end
      end
   )

end



drawtiles()
gamerun = true
creat_co_boby()
screen.update()

function check_dir(x,y)
   local  x1,y1 = x-200, -(y-120)
   local s
   if (x1 > 0 and y1 >= 0) then
      if y1/x1 < 3/5 then
	 s = "R1"
      else
	 s = "T1"
      end
   elseif (x1 < 0 and y1 >= 0) then
      if y1/x1 < -3/5 then
	 s = "T2"
      else
	 s = "L2"
      end
   elseif (x1 < 0 and y1 <= 0) then
      if y1/x1 <  3/5 then
	 s = "L3"
      else
	 s = "B3"
      end
   elseif (x1 > 0 and y1 <= 0) then
      if y1/x1 <  -3/5 then
	 s = "B4"
      else
	 s = "R4"
      end
   elseif (y1 <= 0) then
      s = "B4"
   else
      s = "T2"
   end
   return s
end

function redswitch()
   for w = 0, 24 do
      for h = 0, 14 do
	 if map2[h+1][w+1]==29 then setTile(w,h,28)
	 elseif map2[h+1][w+1]==28 then setTile(w,h,29)
	 elseif map2[h+1][w+1]==27 then setTile(w,h,24)
	 elseif map2[h+1][w+1]==24 then setTile(w,h,25)
	 elseif map2[h+1][w+1]==25 then setTile(w,h,26)
	 elseif map2[h+1][w+1]==26 then setTile(w,h,27)
	 elseif map2[h+1][w+1]==22 then setTile(w,h,23)
	 elseif map2[h+1][w+1]==23 then setTile(w,h,22)
	 end
      end	
   end
end

function yellowswitch()
   for w = 0, 24 do
      for h = 0, 14 do
	 if map2[h+1][w+1]==40 then setTile(w,h,41)
	 elseif map2[h+1][w+1]==41 then setTile(w,h,40)
	 elseif map2[h+1][w+1]==42 then setTile(w,h,43)
	 elseif map2[h+1][w+1]==43 then setTile(w,h,42)
	 elseif map2[h+1][w+1]==38 then setTile(w,h,39)
	 elseif map2[h+1][w+1]==39 then setTile(w,h,38)
	 end
      end	
   end
end

function update_before()
   local x, y = bobypos.x, bobypos.y
   if map2[y+1][x+1]==29 then setTile(x,y,28)
   elseif map2[y+1][x+1]==28 then setTile(x,y,29)
   elseif map2[y+1][x+1]==27 then setTile(x,y,24)
   elseif map2[y+1][x+1]==24 then setTile(x,y,25)
   elseif map2[y+1][x+1]==25 then setTile(x,y,26)
   elseif map2[y+1][x+1]==26 then setTile(x,y,27)
   elseif map2[y+1][x+1]==30 then setTile(x,y,31)
   end
end

function nextlvl()
   text.size(25)
   text.color(white)
   if level +1 <= #maps then
      level = level+1
      text.draw(0,100,"Loading next level: " .. level .. "/" ..  #maps,"center",width)
   else
      text.draw(0,100,"All levels cleared, reseting...","center",width)
      level = 1
   end
   screen.update()
   os.sleep(100)
   reset()
end

function update_after()
   local x, y = bobypos.x, bobypos.y
   if map2[y+1][x+1] == 19 then 
      carrots = carrots -1 
      setTile(x,y,20)
   elseif map2[y+1][x+1]==32 then 
      setTile(x,y,18) 
      silverkey=true
   elseif map2[y+1][x+1]==34 then 
      setTile(x,y,18)
      goldkey=true
   elseif map2[y+1][x+1]==36 then 
      setTile(x,y,18)
      bronzekey=true
   elseif map2[y+1][x+1]==33 then
      setTile(x,y,18)
   elseif map2[y+1][x+1]==35 then 
      setTile(x,y,18)
   elseif map2[y+1][x+1]==37 then 
      setTile(x,y,18)
   elseif map2[y+1][x+1]==22 then 
      redswitch()
   elseif map2[y+1][x+1]==38 then 
      yellowswitch()
   elseif map2[y+1][x+1]==44 or map2[y+1][x+1]==47 then 
      if carrots==0 and eggs==0 then
	 boby_state = "fade"

      end
   elseif map2[y+1][x+1]==45 then 
      eggs = eggs -1
      setTile(x,y,46)
   elseif map2[y+1][x+1]==31 then 
      boby_state = "die"

   end
   if map2[y+1][x+1]==40 then 
      boby_state = "trans_left"
   elseif map2[y+1][x+1]==41 then 
      boby_state = "trans_right"
   elseif map2[y+1][x+1]==42 then
      boby_state = "trans_up"
   elseif map2[y+1][x+1]==43 then
      boby_state = "trans_down"
   end
end

function canmove(dir,x,y)
   local nx=bobypos.x;
   local ny=bobypos.y
   if map2[y+1][x+1]<18 then return false end
   if y<0 or x<0 or y==15 or x==25 then return false end
   if(dir=="up" or dir=="down") and map2[y+1][x+1]==28 then return false end
   if(dir=="left" or dir=="right") and map2[y+1][x+1]==29 then return false end
   if map2[ny+1][nx+1]==28 and (dir=="up" or dir=="down") then return false end
   if map2[ny+1][nx+1]==29 and (dir=="left" or dir=="right") then return false end
   
   if map2[ny+1][nx+1]==27 and (dir=="left" or dir=="down") then return false end
   if map2[ny+1][nx+1]==26 and (dir=="right" or dir=="down") then return false end
   if map2[ny+1][nx+1]==25 and (dir=="right" or dir=="up") then return false end
   if map2[ny+1][nx+1]==24 and (dir=="left" or dir=="up") then return false end
   
   if map2[y+1][x+1]==27 and (dir=="right" or dir=="up") then return false end
   if map2[y+1][x+1]==26 and (dir=="left" or dir=="up") then return false end
   if map2[y+1][x+1]==25 and (dir=="left" or dir=="down") then return false end
   if map2[y+1][x+1]==24 and (dir=="right" or dir=="down") then return false end
   
   if map2[y+1][x+1]==33 and silverkey==false then return false end
   if map2[y+1][x+1]==35 and goldkey==false then return false end
   if map2[y+1][x+1]==37 and bronzekey==false then return false end
   if map2[y+1][x+1]==46 then return false end
   
   if map2[ny+1][nx+1]==44 and carrots==0 and eggs==0 then return false end
   return true
end

function reset()
   map2 = maps[level]()
   carrots=0
   eggs=0
   silverkey=false 
   goldkey=false 
   bronzekey=false
   conveyors=false
   setprops()
   boby_state = "wait"  
   drawtiles()
end

function  togle_goal_tile()
   local x,y = goalpos.x+1, goalpos.y+1
   if  map2[y][x] == 44 then
      map2[y][x] = 47 
   elseif  map2[y][x] == 47 then
      map2[y][x] = 44 
   end
end

function setprops()
   for w = 1, 25 do
      for h = 1, 15 do
	 if map2[h][w] == 21 then
	    bobypos = {x=w-1,y=h-1}
	 elseif map2[h][w]==19 then
	    carrots = carrots +1
	 elseif map2[h][w]==45 then
	    eggs = eggs +1
	 elseif map2[h][w]>=40 and map2[h][w]<=43 then
	    conveyors=true
	 elseif map2[h][w]==44 then
	    goalpos = {x=w-1,y=h-1}
	 end
      end
   end
end

setprops()

while gamerun do 
   if control.read()==1 then
      if control.isTouch()==1 then
         x,y = touch.pos()
         if touch.down() == 1 then
	    s = string.sub(check_dir(x,y),1,1)
	    if s == "L" then
	       boby_state = "left" 
	    elseif s == "R" then
	       boby_state = "right" 
	    elseif s == "T" then
	       boby_state = "up" 
	    elseif s == "B" then
	       boby_state = "down" 
	    end
	 end	    
      elseif control.isButton()==1 then
         if button.click() == 1 then
	    gamerun = false
         end
      end    
   else
      coroutine.resume(co_boby)
      if carrots==0 and eggs==0 and boby_state  == "wait" then
	 togle_goal_tile()
	 drawtile(goalpos.x,goalpos.x,goalpos.y,goalpos.y)
      end
      screen.update()
      os.sleep(5)
   end
end

